//
// ScheduleAPI.h
// Project
//
// Created by haibara on 5/11/17.
//
//

#import <Foundation/Foundation.h>
#import "JavaAppAPI.h"
#import "ScheduleStop.h"
#import "Destination.h"

@interface StopScheduleApi : JavaAppAPI
@end


@interface BookingReportDetail : StopScheduleApi
@property (nonatomic, strong) NSString *departureDate;
@property (nonatomic, assign) NSInteger scheduleId;
@property (nonatomic, assign) BOOL isDBDSearch;
@end

@interface DriverBean : NSObject
@property (nonatomic, assign) NSInteger id;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *email;
@property (nonatomic, strong) NSString *phone;
@property (nonatomic, assign) NSInteger phoneCarrier;
@property (nonatomic, strong, readonly) NSString *phoneCarrierName;
@end

@interface BookingReportDetailBean : NSObject
@property (nonatomic, assign) NSInteger pid;
@property (nonatomic, assign) NSInteger scheduleId;
@property (nonatomic, strong) ScheduleStop *departureScheduleStop;
@property (nonatomic, strong) ScheduleStop *arrivalScheduleStop;
@end

@interface BookingReportSummaryBean : NSObject
@property (nonatomic, strong)NSArray *bookingReportDetailList;
@property (nonatomic, strong) BookingReportDetailBean *defaultBookingReportDetail;
@end

@interface BookingReportDetailResponse : JavaAppAPIResponse
@property (nonatomic, strong)NSArray *bookingReportSummaryList;
@end

@interface CustomerListPage : StopScheduleApi
@property (nonatomic, strong) NSString *departureDate;
@property (nonatomic, assign) NSInteger scheduleStopId;
@property (nonatomic, assign) NSInteger scheduleId;
@property (nonatomic, assign) BOOL isPickUp;
@property (nonatomic, assign) BOOL isDropOff;
@property (nonatomic, assign) BOOL isDBDSearch;
@end

@interface CustomerListPageResponse : JavaAppAPIResponse
@property (nonatomic, strong)NSArray *soldStockList;
@end
