//
// DrawUtils.h
// GotoBus
//
// Created by haibara on 2/12/15.
//
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "FAKFontAwesomeBrands.h"
#import "FAKFontAwesomeRegular.h"
#import "FAKFontAwesomeSolid.h"
#import <FontAwesomeKit/FontAwesomeKit.h>

@interface DrawUtils : NSObject

+ (UIView *)tableViewCellAccessoryDisclosureIndicatorRightWithColor:(UIColor *)color;
+ (UIView *)tableViewCellAccessoryDisclosureIndicatorDownWithColor:(UIColor *)color;

+ (void)addBorderToRect:(UIView *)view byEdges:(UIRectEdge)edges strokeColor:(UIColor *)strokeColor;
+ (void)addBorderToRect:(UIView *)view byEdges:(UIRectEdge)edges strokeColor:(UIColor *)strokeColor borderWidth:(CGFloat)borderWidth;
+ (void)addSolidBorderToRect:(UIView *)view strokeColor:(UIColor *)strokeColor;
+ (void)addSolidBorderToRect:(UIView *)view strokeColor:(UIColor *)strokeColor borderWidth:(CGFloat)borderWidth;
+ (void)addRoundedBorderToRect:(UIView *)view cornerRadius:(CGFloat)cornerRadius;
+ (void)addRoundedBorderToRect:(UIView *)view cornerRadius:(CGFloat)cornerRadius strokeColor:(UIColor *)strokeColor;
+ (void)addRoundedBorderToRect:(UIView *)view cornerRadius:(CGFloat)cornerRadius strokeColor:(UIColor *)strokeColor borderWidth:(CGFloat)borderWidth;
+ (void)addRoundedBorderToRect:(UIView *)view byRoundingCorners:(UIRectCorner)corners cornerRadius:(CGFloat)cornerRadius;
+ (void)inscribeOvalToRect:(UIView *)view;
+ (void)inscribeOvalToRect:(UIView *)view strokeColor:(UIColor *)strokeColor;
+ (void)inscribeOvalToRect:(UIView *)view strokeColor:(UIColor *)strokeColor borderWidth:(CGFloat)borderWidth;
+ (void)addShadowToRect:(UIView *)view;

+ (NSAttributedString *)attributedStringWithFAKIcon:(FAKIcon *)icon fillColor:(UIColor *)fillColor;
+ (UIImage *)imageWithFAKIcon:(FAKIcon *)icon fillColor:(UIColor *)fillColor;
+ (UIImage *)tableViewCellImageWithFAKIcon:(FAKIcon *)icon fillColor:(UIColor *)fillColor;

@end
