//
// IMLocalization.h
// MyProject
//
// Created by haibara on 6/10/15.
//
//

#import <Foundation/Foundation.h>
#import <LocalizationPOC/LocalizationSystem.h>

#define IMLocalizedString(key) [[IMLocalization sharedInstance] localizedStringForKey: (key)value: @"" table: nil]
#define IMLocalizedImage(name) [[IMLocalization sharedInstance] localizedImage: (name)]
#define IMLocalizedPath(name, extension) [[IMLocalization sharedInstance] localizedPathForResource: (name)ofType: (extension)]

@interface IMLocalization : LocalizationSystem
+ (instancetype)sharedInstance;
- (BOOL)hasPreferredLanguage;
- (NSString *)localizedPathForResource:(NSString *)name ofType:(NSString *)extension;
@end
